﻿// Decompiled with JetBrains decompiler
// Type: TechLifeForum.IrcClient
// Assembly: IrcClient, Version=1.0.0.0, Culture=neutral, PublicKeyToken=null
// MVID: C551EB8D-7AAB-4820-9BBF-F663D8614FC8
// Assembly location: D:\I miei backup\MedGui Reborn\MedGui Reborn\bin\Debug\IrcClient.dll

using System;
using System.ComponentModel;
using System.IO;
using System.Net.Sockets;
using System.Text.RegularExpressions;
using System.Threading;

namespace TechLifeForum
{
  public class IrcClient
  {
    private string _server = "";
    private int _port = 6667;
    private string _ServerPass = "";
    private string _nick = "Test";
    private string _altNick = "";
    private TcpClient irc;
    private NetworkStream stream;
    private string inputLine;
    private StreamReader reader;
    private StreamWriter writer;
    private AsyncOperation op;

    public string Server
    {
      get
      {
        return this._server;
      }
    }

    public int Port
    {
      get
      {
        return this._port;
      }
    }

    public string ServerPass
    {
      get
      {
        return this._ServerPass;
      }
      set
      {
        this._ServerPass = value;
      }
    }

    public string Nick
    {
      get
      {
        return this._nick;
      }
      set
      {
        this._nick = value;
      }
    }

    public string AltNick
    {
      get
      {
        return this._altNick;
      }
      set
      {
        this._altNick = value;
      }
    }

    public bool Connected
    {
      get
      {
        return this.irc != null && this.irc.Connected;
      }
    }

    public event UpdateUserListEventDelegate UpdateUsers;

    public event UserJoinedEventDelegate UserJoined;

    public event UserLeftEventDelegate UserLeft;

    public event UserNickChangeEventDelegate UserNickChange;

    public event ChannelMesssageEventDelegate ChannelMessage;

    public event NoticeMessageEventDelegate NoticeMessage;

    public event PrivateMessageEventDelegate PrivateMessage;

    public event ServerMessageEventDelegate ServerMessage;

    public event NickTakenEventDelegate NickTaken;

    public event ConnectedEventDelegate OnConnect;

    public event ExceptionThrownEventDelegate ExceptionThrown;

    public IrcClient(string Server, int Port)
    {
      this.op = AsyncOperationManager.CreateOperation((object) null);
      this._server = Server;
      this._port = Port;
    }

    public IrcClient(string Server)
    {
      this.op = AsyncOperationManager.CreateOperation((object) null);
      this._server = Server;
      this._port = 6667;
    }

    private void Fire_UpdateUsers(IrcClient.oUserList o)
    {
      if (this.UpdateUsers == null)
        return;
      this.UpdateUsers(o.Channel, o.UserList);
    }

    private void Fire_UserJoined(IrcClient.oUserJoined o)
    {
      if (this.UserJoined == null)
        return;
      this.UserJoined(o.Channel, o.User);
    }

    private void Fire_UserLeft(IrcClient.oUserLeft o)
    {
      if (this.UserLeft == null)
        return;
      this.UserLeft(o.Channel, o.User);
    }

    private void Fire_NickChanged(IrcClient.oUserNickChanged o)
    {
      if (this.UserNickChange == null)
        return;
      this.UserNickChange(o.Old, o.New);
    }

    private void Fire_ChannelMessage(IrcClient.oChannelMessage o)
    {
      if (this.ChannelMessage == null)
        return;
      this.ChannelMessage(o.Channel, o.From, o.Message);
    }

    private void Fire_NoticeMessage(IrcClient.oNoticeMessage o)
    {
      if (this.NoticeMessage == null)
        return;
      this.NoticeMessage(o.From, o.Message);
    }

    private void Fire_PrivateMessage(IrcClient.oPrivateMessage o)
    {
      if (this.PrivateMessage == null)
        return;
      this.PrivateMessage(o.From, o.Message);
    }

    private void Fire_ServerMesssage(string s)
    {
      if (this.ServerMessage == null)
        return;
      this.ServerMessage(s);
    }

    private void Fire_NickTaken(string s)
    {
      if (this.NickTaken == null)
        return;
      this.NickTaken(s);
    }

    private void Fire_Connected()
    {
      if (this.OnConnect == null)
        return;
      this.OnConnect();
    }

    private void Fire_ExceptionThrown(Exception ex)
    {
      if (this.ExceptionThrown == null)
        return;
      this.ExceptionThrown(ex);
    }

    public void Connect()
    {
      new Thread(new ThreadStart(this.DoConnect))
      {
        IsBackground = true
      }.Start();
    }

    private void DoConnect()
    {
      try
      {
        this.irc = new TcpClient(this._server, this._port);
        this.stream = this.irc.GetStream();
        this.reader = new StreamReader((Stream) this.stream);
        this.writer = new StreamWriter((Stream) this.stream);
        if (!string.IsNullOrEmpty(this._ServerPass))
          this.Send("PASS " + this._ServerPass);
        this.Send("NICK " + this._nick);
        this.Send("USER " + this._nick + " 0 * :" + this._nick);
        this.Listen();
      }
      catch (Exception ex)
      {
        this.op.Post((SendOrPostCallback) (x => this.Fire_ExceptionThrown((Exception) x)), (object) ex);
      }
    }

    public void Disconnect()
    {
      if (this.irc == null)
        return;
      if (this.irc.Connected)
        this.Send("QUIT Client Disconnected: http://tech.reboot.pro");
      this.irc = (TcpClient) null;
    }

    public void JoinChannel(string Channel)
    {
      if (this.irc == null || !this.irc.Connected)
        return;
      this.Send("JOIN " + Channel);
    }

    public void PartChannel(string Channel)
    {
      this.Send("PART " + Channel);
    }

    public void SendNotice(string Nick, string message)
    {
      this.Send("NOTICE " + Nick + " :" + message);
    }

    public void SendMessage(string Channel, string Message)
    {
      this.Send("PRIVMSG " + Channel + " :" + Message);
    }

    public void SendRAW(string message)
    {
      this.Send(message);
    }

    private void Listen()
    {
      while ((this.inputLine = this.reader.ReadLine()) != null)
      {
        this.ParseData(this.inputLine);
        Console.Write(this.inputLine);
      }
    }

    private void ParseData(string data)
    {
      string[] strArray = data.Split(' ');
      if (data.Length > 4 && data.Substring(0, 4) == "PING")
      {
        this.Send("PONG " + strArray[1]);
      }
      else
      {
        switch (strArray[1])
        {
          case "001":
            this.Send("MODE " + this._nick + " +B");
            this.op.Post((SendOrPostCallback) (x => this.Fire_Connected()), (object) null);
            break;
          case "353":
            this.op.Post((SendOrPostCallback) (x => this.Fire_UpdateUsers((IrcClient.oUserList) x)), (object) new IrcClient.oUserList(strArray[4], this.JoinArray(strArray, 5).Split(new char[1]
            {
              ' '
            }, StringSplitOptions.RemoveEmptyEntries)));
            break;
          case "433":
            this.op.Post((SendOrPostCallback) (x => this.Fire_NickTaken((string) x)), (object) strArray[3]);
            if (strArray[3] == this._altNick)
            {
              Random random = new Random();
              string str = "Guest" + (object) random.Next(0, 9) + (object) random.Next(0, 9) + (object) random.Next(0, 9);
              this.Send("NICK " + str);
              this.Send("USER " + str + " 0 * :" + str);
              this._nick = str;
              break;
            }
            this.Send("NICK " + this._altNick);
            this.Send("USER " + this._altNick + " 0 * :" + this._altNick);
            this._nick = this._altNick;
            break;
          case "JOIN":
            this.op.Post((SendOrPostCallback) (x => this.Fire_UserJoined((IrcClient.oUserJoined) x)), (object) new IrcClient.oUserJoined(strArray[2], strArray[0].Substring(1, strArray[0].IndexOf("!") - 1)));
            break;
          case "NICK":
                        this.op.Post((SendOrPostCallback)(x => this.Fire_NickChanged((IrcClient.oUserNickChanged)x)), (object)new IrcClient.oUserNickChanged(strArray[0].Substring(1, strArray[0].IndexOf("!") - 1), strArray[2].Substring(1)));
            break;
          case "NOTICE":
            if (strArray[0].Contains("!"))
            {
              this.op.Post((SendOrPostCallback) (x => this.Fire_NoticeMessage((IrcClient.oNoticeMessage) x)), (object) new IrcClient.oNoticeMessage(strArray[0].Substring(1, strArray[0].IndexOf('!') - 1), this.JoinArray(strArray, 3)));
              break;
            }
            this.op.Post((SendOrPostCallback) (x => this.Fire_NoticeMessage((IrcClient.oNoticeMessage) x)), (object) new IrcClient.oNoticeMessage(this._server, this.JoinArray(strArray, 3)));
            break;
          case "PRIVMSG":
            if (strArray[2].ToLower() == this._nick.ToLower())
            {
              this.op.Post((SendOrPostCallback) (x => this.Fire_PrivateMessage((IrcClient.oPrivateMessage) x)), (object) new IrcClient.oPrivateMessage(strArray[0].Substring(1, strArray[0].IndexOf('!') - 1), this.JoinArray(strArray, 3)));
              break;
            }
            this.op.Post((SendOrPostCallback) (x => this.Fire_ChannelMessage((IrcClient.oChannelMessage) x)), (object) new IrcClient.oChannelMessage(strArray[2], strArray[0].Substring(1, strArray[0].IndexOf('!') - 1), this.JoinArray(strArray, 3)));
            break;
          case "PART":
          case "QUIT":
            this.op.Post((SendOrPostCallback) (x => this.Fire_UserLeft((IrcClient.oUserLeft) x)), (object) new IrcClient.oUserLeft(strArray[2], strArray[0].Substring(1, data.IndexOf("!") - 1)));
            this.Send("NAMES " + strArray[2]);
            break;
          default:
            if (strArray.Length <= 3)
              break;
            this.op.Post((SendOrPostCallback) (x => this.Fire_ServerMesssage((string) x)), (object) this.JoinArray(strArray, 3));
            break;
        }
      }
    }

    private string StripMessage(string message)
    {
      foreach (Match match in new Regex(3.ToString() + "(?:\\d{1,2}(?:,\\d{1,2})?)?").Matches(message))
        message = message.Replace(match.Value, "");
      if (message == "")
        return "";
      if (message.Substring(0, 1) == ":" && message.Length > 2)
        return message.Substring(1, message.Length - 1);
      return message;
    }

    private string JoinArray(string[] strArray, int startIndex)
    {
      return this.StripMessage(string.Join(" ", strArray, startIndex, strArray.Length - startIndex));
    }

    private void Send(string message)
    {
      this.writer.WriteLine(message);
      this.writer.Flush();
    }

    public struct oUserList
    {
      public string Channel;
      public string[] UserList;

      public oUserList(string Channel, string[] UserList)
      {
        this.Channel = Channel;
        this.UserList = UserList;
      }
    }

    public struct oUserJoined
    {
      public string Channel;
      public string User;

      public oUserJoined(string Channel, string User)
      {
        this.Channel = Channel;
        this.User = User;
      }
    }

    public struct oUserLeft
    {
      public string Channel;
      public string User;

      public oUserLeft(string Channel, string User)
      {
        this.Channel = Channel;
        this.User = User;
      }
    }

    public struct oChannelMessage
    {
      public string Channel;
      public string From;
      public string Message;

      public oChannelMessage(string Channel, string From, string Message)
      {
        this.Channel = Channel;
        this.From = From;
        this.Message = Message;
      }
    }

    public struct oNoticeMessage
    {
      public string From;
      public string Message;

      public oNoticeMessage(string From, string Message)
      {
        this.From = From;
        this.Message = Message;
      }
    }

    public struct oPrivateMessage
    {
      public string From;
      public string Message;

      public oPrivateMessage(string From, string Message)
      {
        this.From = From;
        this.Message = Message;
      }
    }

    public struct oUserNickChanged
    {
      public string Old;
      public string New;

      public oUserNickChanged(string Old, string New)
      {
        this.Old = Old;
        this.New = New;
      }
    }
  }
}
